#The MIT License (MIT)
#
#Copyright (C) 2014 OpenBet Limited
#
#Permission is hereby granted, free of charge, to any person obtaining a copy of
#this software and associated documentation files (the "Software"), to deal in
#the Software without restriction, including without limitation the rights to
#use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies
#of the Software, and to permit persons to whom the Software is furnished to do
#so, subject to the following conditions:
#
#The above copyright notice and this permission notice shall be included in all
#copies or substantial portions of the Software.
#
#THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#ITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
#THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
#SOFTWARE.

from shutit_module import ShutItModule

class casperjs(ShutItModule):

	def is_installed(self, shutit):
		return shutit.file_exists('/opt/casperjs', directory=True)

	def build(self, shutit):
		shutit.install('git')
		shutit.run_script("""
			#!/bin/bash
			cd /opt
			git clone git://github.com/n1k0/casperjs.git
			cd casperjs
			git checkout tags/1.0.2
		""", in_shell=False)
		return True

	def remove(self, shutit):
		shutit.send('rm -rf /opt/casperjs')
		return True

def module():
	return casperjs(
		'shutit.tk.casperjs.casperjs', 0.314,
		description='http://casperjs.org/',
		depends=['shutit.tk.setup']
	)

